#include <bits/stdc++.h>
#define endl '\n'

#define SZ(x) ((int)x.size())
#define ALL(V) V.begin(), V.end()
#define L_B lower_bound
#define U_B upper_bound
#define pb push_back

using namespace std;
template<class T, class T1> int chkmin(T &x, const T1 &y) { return x > y ? x = y, 1 : 0; }
template<class T, class T1> int chkmax(T &x, const T1 &y) { return x < y ? x = y, 1 : 0; }
const int MAXN = (1 << 20);
const double PI = acos(-1);

using base = complex<double>;

int bit_rev[MAXN];

void fft(base *a, int lg)
{
	int n = (1 << lg);
	for(int i = 1; i < n; i++)
	{
		bit_rev[i] = (bit_rev[i >> 1] >> 1) | ((i & 1) << (lg - 1));
		if(bit_rev[i] < i) swap(a[i], a[bit_rev[i]]);
	}

	for(int len = 2; len <= n; len <<= 1)
	{
		double ang = 2 * PI / len;
		base w(1, 0), wn(cos(ang), sin(ang));

		for(int j = 0; j < (len >> 1); j++, w *= wn)
			for(int i = 0; i < n; i += len)
			{
				base u = a[i + j], v = a[i + j + (len >> 1)] * w;
				a[i + j] = u + v;
				a[i + j + (len >> 1)] = u - v;
			}
	}
}

void inv_fft(base *a, int lg)
{
	int n = (1 << lg);
	for(int i = 1; i < n; i++)
	{
		bit_rev[i] = (bit_rev[i >> 1] >> 1) | ((i & 1) << (lg - 1));
		if(bit_rev[i] < i) swap(a[i], a[bit_rev[i]]);
	}

	for(int len = 2; len <= n; len <<= 1)
	{
		double ang = -2 * PI / len;
		base w(1, 0), wn(cos(ang), sin(ang));

		for(int j = 0; j < (len >> 1); j++, w *= wn)
			for(int i = 0; i < n; i += len)
			{
				base u = a[i + j], v = a[i + j + (len >> 1)] * w;
				a[i + j] = u + v;
				a[i + j + (len >> 1)] = u - v;
			}
	}

	for(int i = 0; i < n; i++)
		a[i] /= n;
}

int n, k;

void fix(vector<double> &li)
{
	for(int i = SZ(li) - 1; i >= n; i--)
		li[i % n] += li[i];
	while(SZ(li) > n) li.pop_back();
}

base A[MAXN], B[MAXN];
vector<double> initial;

void read()
{
	cin >> n >> k;
	initial.resize(n);
	for(double &v: initial)
		cin >> v;
}

vector<double> mult(const vector<double> &a, const vector<double> &b)
{
	if(SZ(a) * 1ll * SZ(b) < 2000)
	{
		vector<double> c(SZ(a) + SZ(b), 0);
		for(int i = 0; i < SZ(a); i++)
		for(int j = 0; j < SZ(b); j++)
			c[i + j] += a[i] * b[j];
	
		return c;
	}

	int lg = 0;
	while((1 << lg) <= (SZ(a) + SZ(b) + 1)) lg++;
	for(int i = 0; i < (1 << lg); i++) A[i] = B[i] = 0;
	for(int i = 0; i < SZ(a); i++) A[i] = a[i];
	for(int i = 0; i < SZ(b); i++) B[i] = b[i];

	fft(A, lg), fft(B, lg);
	for(int i = 0; i < (1 << lg); i++)
		A[i] *= B[i];
	inv_fft(A, lg);

	vector<double> c(SZ(a) + SZ(b), 0);
	for(int i = 0; i < SZ(c); i++)
		c[i] = A[i].real();

	return c;
}

vector<double> f(const vector<double> &x, int p)
{
	if(p == 1) return x;

	if(p % 2)
	{
		auto it = mult(x, f(x, p - 1));
		fix(it);
		return it;
	}

	auto it = f(x, p / 2);
	it = mult(it, it);
	fix(it);
	return it;
}

void solve()
{
	initial = f(initial, k);
	for(double x: initial)
		cout << setprecision(9) << fixed << x << " ";
	cout << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	read();
	solve();
	return 0;
}
