#include <bits/stdc++.h>
#define endl '\n'

#define SZ(x) ((int)x.size())
#define ALL(V) V.begin(), V.end()
#define L_B lower_bound
#define U_B upper_bound
#define pb push_back

using namespace std;
template<class T, class T1> int chkmin(T &x, const T1 &y) { return x > y ? x = y, 1 : 0; }
template<class T, class T1> int chkmax(T &x, const T1 &y) { return x < y ? x = y, 1 : 0; }
const int MAXN = (1 << 20);

struct Graph
{
	int N, M;
	vector<pair<int, int> > adj[MAXN];

	void init(int n, int m)
	{
		N = n, M = m;
		for(int i = 0; i <= n; i++) 
			adj[i].clear();
	}

	void add_edge(int u, int v, int w)
	{
		adj[u].pb({v, w});
		adj[v].pb({u, w});
	}

	void get_graph()
	{
		cin >> N >> M;
		init(N, M);

		for(int i = 0; i < M; i++)
		{
			int u, v, w;
			cin >> u >> v >> w;
			adj[u].pb({v, w});
			adj[v].pb({u, w});
		}
	}

	bool in_queue[MAXN];
	int64_t D[MAXN];

	int64_t dist(int a, int b)
	{
		queue<int> Q;
		for(int i = 1; i <= N; i++) D[i] = (int64_t)1e18, in_queue[i] = false;
		
		Q.push(a);
		D[a] = 0;

		while(!Q.empty())
		{
			int u = Q.front();
			Q.pop();
			in_queue[u] = false;

			for(auto e: adj[u])
				if(chkmin(D[e.first], D[u] + e.second) && !in_queue[e.first])
					in_queue[e.first] = true, Q.push(e.first);
		}

		return D[b];
	}
};

int ProblemID;
Graph X, Y;

void read()
{
	cin >> ProblemID;
	X.get_graph();
	Y.get_graph();
}

void solve()
{
	if(ProblemID == 1)
		cout << X.dist(1, X.N) + Y.dist(1, Y.N) << endl; 
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	read();
	solve();
	return 0;
}
