#include <bits/stdc++.h>
#define endl '\n'

#define SZ(x) ((int)x.size())
#define ALL(V) V.begin(), V.end()
#define L_B lower_bound
#define U_B upper_bound
#define pb push_back

using namespace std;
template<class T, class T1> int chkmin(T &x, const T1 &y) { return x > y ? x = y, 1 : 0; }
template<class T, class T1> int chkmax(T &x, const T1 &y) { return x < y ? x = y, 1 : 0; }
const int MAXN = (1 << 20);

mt19937 mt(42);
struct dsu
{
	int comps;
	int par[MAXN];

	void init(int n)
	{
		comps = n;
		for(int i = 1; i <= n; i++)
			par[i] = i;
	}

	int root(int x) { return (x == par[x]) ? x : (par[x] = root(par[x])); }

	bool unite(int u, int v)
	{
		u = root(u), v = root(v);
		if(u == v) return false;
		
		comps--;
		if(mt() % 2) swap(u, v);
		par[u] = v;

		return true;
	}
};

struct Graph
{
	struct edge
	{
		int u, v, w;
		edge() { u = v = w = 0; }
		edge(int _u, int _v, int _w) { u = _u; v = _v; w = _w; }
		bool operator<(const edge &other) { return w < other.w; }
	};

	int N, M;
	dsu uf;
	vector<pair<int, int> > adj[MAXN];
	vector<edge> ed;

	void init(int n, int m)
	{
		N = n, M = m;
		for(int i = 0; i <= n; i++) 
			adj[i].clear();
	}

	void add_edge(int u, int v, int w)
	{
		adj[u].pb({v, w});
		adj[v].pb({u, w});
	}

	void get_graph()
	{
		cin >> N >> M;
		init(N, M);

		for(int i = 0; i < M; i++)
		{
			int u, v, w;
			cin >> u >> v >> w;
			adj[u].pb({v, w});
			adj[v].pb({u, w});
			ed.pb(edge(u, v, w));
		}

		sort(ALL(ed));
		uf.init(N);
	}

	bool in_queue[MAXN];
	int64_t D[MAXN];

	int64_t dist(int a, int b)
	{
		queue<int> Q;
		for(int i = 1; i <= N; i++) D[i] = (int64_t)1e18, in_queue[i] = false;
		
		Q.push(a);
		D[a] = 0;

		while(!Q.empty())
		{
			int u = Q.front();
			Q.pop();
			in_queue[u] = false;

			for(auto e: adj[u])
				if(chkmin(D[e.first], D[u] + e.second) && !in_queue[e.first])
					in_queue[e.first] = true, Q.push(e.first);
		}

		return D[b];
	}
};

int ProblemID;
Graph X, Y;

void read()
{
	cin >> ProblemID;
	X.get_graph();
	Y.get_graph();
}

void solve()
{
	if(ProblemID == 1)
		cout << X.dist(1, X.N) + Y.dist(1, Y.N) << endl; 
	else
	{
		int64_t answer = 0;
		int i = 0, j = 0;
		while(i < X.M && j < Y.M)
		{
			auto e1 = X.ed[i], e2 = Y.ed[j];
			
			if(e1.w > e2.w) 
			{
				j++;
				e1 = e2;
				if(Y.uf.unite(e1.u, e1.v))
					answer += e1.w * 1ll * X.uf.comps;
			}
			else 
			{
				i++;
				if(X.uf.unite(e1.u, e1.v))
					answer += e1.w * 1ll * Y.uf.comps;
			}
		}

		while(i < X.M)
		{
			auto e1 = X.ed[i];
			i++;

			if(X.uf.unite(e1.u, e1.v))
				answer += e1.w * 1ll * Y.uf.comps;
		}

		while(j < Y.M)
		{
			auto e1 = Y.ed[j];
			j++;

			if(Y.uf.unite(e1.u, e1.v))
				answer += e1.w * 1ll * X.uf.comps;
		}

		cout << answer << endl;
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	read();
	solve();
	return 0;
}
