/*
Toi ne ni e veche brat -
zhivite ot vragovete
murtva gi vulna pomete
neide kum otsreshtnii bryag.

Eto, v hlutnalya slog
legnal e spokoino bleden,
s primirena skrub zagledan
v svoda yasen i dulbok.

I po sivata zemq,
toplena ot laski yuzhni,
trepkat plahi i nenuzhni
s kruv napliskani pisma

Koi e toi i de e bil?
Chii go zov pri nas dovede
v den na vihreni pobedi
da umre, nepobedil?

Kleta maichina ruka,
ti li go v nevolya cherna
s dumi na lyubov bezmerna
uteshi i prilaska?

Smeshna zhal, nelepa zhal,
v grohotno zhestoko vreme!
Ne zhivot li da otneme,
toi zhivota svoi e dal?

I nima pod vrazhi styag
gotvil e za nas poshtada?
Ne, toi vze shto mu se pada,
murtviyat ne ni e vrag!
*/
#include <iostream>
#include <cstdint>
#include <vector>
#include <algorithm>
#include <queue>

namespace Task1 {
	const uint64_t INF = 1ULL << 60;

	struct Vertex; 
	struct Edge {
		Vertex *to;
		uint32_t w;
	};

	struct Vertex {
		std::vector<Edge> edges;
		uint64_t dist;

		Vertex(): dist(INF) {}
	};

	struct QVert {
		uint64_t dist;
		Vertex *v;
		friend bool operator< (const QVert &a, const QVert &b) {
			return a.dist > b.dist;
		}
	};

	typedef std::vector<Vertex> Graph;
	Graph x, y;

	void read_graph(Graph &g) {
		uint32_t vCnt, eCnt;
		std::cin >> vCnt >> eCnt;

		g.resize(vCnt);
		for (uint32_t i = 0;i < eCnt;i++) {
			uint32_t u, v, w;
			std::cin >> u >> v >> w;

			u--;
			v--;

			g[u].edges.push_back({&g[v], w});
			g[v].edges.push_back({&g[u], w});
		}
	}
	uint64_t shortest_path(Graph &g) {
		std::priority_queue<QVert> next;
		g[0].dist = 0;
		next.push({0, &g[0]});

		while (!next.empty()) {
			auto p = next.top();
			next.pop();
			Vertex *v = p.v;
			if (p.dist != v->dist) {
				continue;
			}
			
			for (const Edge &e : v->edges) {
				uint64_t nDist = e.w + v->dist;
				if (nDist < e.to->dist) {
					e.to->dist = nDist;
					next.push({nDist, e.to});
				}
			}
		}
		return g.back().dist;
	}
	void solve() {
		read_graph(x);
		read_graph(y);
		std::cout << shortest_path(x) + shortest_path(y) << "\n";
	}
}

namespace Task2 {
	struct Edge {
		bool x;
		uint32_t u, v;
		uint32_t w;
		friend bool operator< (const Edge &a, const Edge &b) {
			return a.w < b.w;
		}
		void read() {
			std::cin >> u >> v >> w;
			u--;
			v--;
		}
	};

	template <size_t N>
	class DSU {
	private:
		uint32_t par[N];
		uint32_t sz[N];
	public:
		DSU() {
			for (uint32_t i = 0;i < N;i++) {
				par[i] = i;
				sz[i] = 1;
			}
		}
		uint32_t find(uint32_t a) {
			if (a != par[a]) {
				par[a] = find(par[a]);
			}
			return par[a];
		}
		bool merge(uint32_t a, uint32_t b) {
			a = find(a);
			b = find(b);

			if (a == b) {
				return false;
			}
			if (sz[a] > sz[b]) {
				par[b] = a;
				sz[a] += sz[b];
			} else {
				par[a] = b;
				sz[b] += sz[a];
			}
			return true;
		}
	};

	const uint32_t MAX_N = 1e5;
	DSU<MAX_N> xDsu, yDsu;
	uint64_t xV, yV;

	std::vector<Edge> edges;
	void input() {
		uint32_t xE;
		std::cin >> xV >> xE;

		for (uint32_t i = 0;i < xE;i++) {
			Edge e;
			e.read();
			e.x = true;
			edges.push_back(e);
		}

		uint32_t yE;
		std::cin >> yV >> yE;

		for (uint32_t i = 0;i < yE;i++) {
			Edge e;
			e.read();
			e.x = false;
			edges.push_back(e);
		}
	}

	uint64_t kruskal() {
		std::sort(edges.begin(), edges.end());
		uint64_t ans = 0;
		for (const Edge &e : edges) {
			if (e.x) {
				if (xDsu.merge(e.u, e.v)) {
					ans += yV * e.w;			
					xV--;
				}
			} else {
				if (yDsu.merge(e.u, e.v)) {
					ans += xV * e.w;
					yV--;
				}
			}
		}
		return ans;
	}
	void solve() {
		input();
		std::cout << kruskal() << "\n";
	}

}

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(nullptr);

	uint32_t taskT;
	std::cin >> taskT;
	if (taskT == 1) {
		Task1::solve();
	} else {
		Task2::solve();
	}
}


