#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 50007;
const long long INF = 1000000000000000007;

struct edge {
  int from, to, w;
  
  edge(int a = 0, int b = 0, int c = 0):
    from(a),
    to(b),
    w(c)
  {}

  bool operator <(const edge &a) const {
    return w<a.w;
  }
};

int type, n1, n2, m1, m2;
vector < pair < int, int > > v1[N], v2[N];
long long dist_g1_1[N], dist_g1_n[N], dist_g2_1[N], dist_g2_n[N];
bool in[N];
long long ans;
edge e1[N], e2[N];
int parents[N], size[N];
long long s1, s2;

void initialize(int n) {
  for(int i=1;i<=n;i++) {
    parents[i] = i;
    size[i] = 1;
  }
}

int find(int x) {
  while(x!=parents[x]) {
    parents[x] = parents[parents[x]];
    x = parents[x];
  }

  return x;
}

bool join(int x, int y) {
  x = find(x);
  y = find(y);

  if(x==y) return false;

  if(size[x]>=size[y]) {
    size[x] += size[y];
    parents[y] = x;
  }
  else {
    size[y] += size[x];
    parents[x] = y;
  }

  return true;
}

void spfa(int n, int start, long long *dist, vector < pair < int, int > > *v) {
  int curr, i;
	queue < int > q;

  fill(dist + 1, dist + 1 + n, numeric_limits < long long >::max());
	fill(in + 1, in + 1 + n, false);

  dist[start] = 0;
  q.push(start);
  in[start] = true;

  while(!q.empty()) {
    curr = q.front();
    q.pop();
    in[curr] = false;

    for(i=0;i<(int)(v[curr].size());i++) {
      long long d = dist[curr] + v[curr][i].second;

      if(d<dist[v[curr][i].first]) {
        dist[v[curr][i].first] = d;

        if(!in[v[curr][i].first]) {
          q.push(v[curr][i].first);
          in[v[curr][i].first] = true;
        }
      }
    }
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int trees, i, x, y, z;

  scanf("%d", &type);
  
  scanf("%d %d", &n1, &m1);
  for(i=1;i<=m1;i++) {
    scanf("%d %d %d", &x, &y, &z);
    e1[i] = edge(x, y, z);

    v1[x].push_back(make_pair(y, z));
    v1[y].push_back(make_pair(x, z));
  }

  scanf("%d %d", &n2, &m2);
  for(i=1;i<=m2;i++) {
    scanf("%d %d %d", &x, &y, &z);
    e2[i] = edge(x, y, z);

    v2[x].push_back(make_pair(y, z));
    v2[y].push_back(make_pair(x, z));
  }

  if(type==2) {
    sort(e1 + 1, e1 + 1 + m1);
    trees = n1;
    
    initialize(n1);
    for(i=1;i<=m1 && trees>1;i++) {
      if(join(e1[i].from, e1[i].to)) {
        --trees;
        s1 += e1[i].w;
      }
    }

    sort(e2 + 1, e2 + 1 + m2);
    trees = n2;
    
    initialize(n2);
    for(i=1;i<=m2 && trees>1;i++) {
      if(join(e2[i].from, e2[i].to)) {
        --trees;
        s2 += e2[i].w;
      }
    }

    printf("%lld\n", min(s1 * n2 + s2, s2 * n1 + s1));

    return 0;
  }

  spfa(n1, 1, dist_g1_1, v1);
  spfa(n1, n1, dist_g1_n, v1);
  spfa(n2, 1, dist_g2_1, v2);
  spfa(n2, n2, dist_g2_n, v2);

  ans = INF;
  
  for(i=1;i<=n1;i++) {
    ans = min(ans, dist_g1_1[i] + dist_g2_1[n2] + dist_g1_n[i]);
  }
  for(i=1;i<=n2;i++) {
    ans = min(ans, dist_g2_1[i] + dist_g1_1[n1] + dist_g2_n[i]);
  }

  printf("%lld\n", dist_g1_1[n1] + dist_g2_1[n2]);

  return 0;
}
