#include <bits/stdc++.h>

using namespace std;

const int N = 1e4 + 7;

vector<long double> p;

vector<long double> multiply(vector<long double> a, vector<long double> b){
    vector<long double> ans;

    int n = (int)max(a.size(), b.size());

    for(int i = 0; i < n; i++){
        ans.push_back((long double)0.0);
    }

    for(int i = 0; i < a.size(); i++){
        for(int j = 0; j < b.size(); j++){
            ans[(i + j) % n] += (long double)a[i] * b[j];
        }
    }

    return ans;
}

vector<long double> ans;

void fast_pow(long long exp){
    if(exp == 0){
        ans.clear();
        ans.push_back((long double)1.0);

        return;
    }

    if(exp & 1){
        fast_pow(exp - 1);

        ans = multiply(ans, p);

        return;
    }

    fast_pow(exp >> 1);

    ans = multiply(ans, ans);
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int n, k;

    cin >> n >> k;

    for(int i = 0; i < n; i++){
        long double x;
        cin >> x;

        p.push_back(x);
    }

    fast_pow(k);


    for(int i = 0; i < n; i++){
        cout << fixed << setprecision(8) << ans[i] << " ";
    }
    cout << "\n";

    return 0;
}
