#include <bits/stdc++.h>

using namespace std;

const int N = 1e4 + 7;
using cd = complex<long double>;

long double pi = (long double)acos(-1.0);

int real_n;

vector<long double> p;

void fft(vector<cd> &a, bool invert){
    int n = a.size();

    for(int i = 1, j = 0; i < n; i++){
        int bit = n >> 1;
        for(; j & bit; bit >>= 1){
            j ^= bit;
        }
        j ^= bit;

        if(i < j){
            swap(a[i], a[j]);
        }
    }

    /*for(int i = 0; i < n; i++){
        cout << a[i] << " ";
    }
    cout << endl;*/

    for(int len = 2; len <= n; len <<= 1){
        long double ang = 2 * pi / len * (invert ? -1 : 1);
        cd wlen(cos(ang), sin(ang));
        for(int i = 0; i < n; i += len){
            cd w(1);

            for(int j = 0; j < len / 2; j++){
                cd u = a[i + j], v = a[i + j + len / 2] * w;

                a[i + j] = u + v;
                a[i + j + len / 2] = u - v;

                w *= wlen;
            }
        }
    }

    if(invert){
        for(cd &t: a){
            t /= (long double)n;
        }
    }
}

vector<long double> multiply(const vector<long double> &a, const vector<long double> &b){
    vector<cd> fa(a.begin(), a.end()), fb(b.begin(), b.end());

    int n = 1;

    while(n < a.size() + b.size()){
        n <<= 1;
    }

    fa.resize(n);
    fb.resize(n);

    fft(fa, false);
    fft(fb, false);

    for(int i = 0; i < n; i++){
        fa[i] *= fb[i];
    }

    fft(fa, true);

    vector<long double> ans;

    for(int i = 0; i < fa.size(); i++){
        cd c = fa[i];

        long double t = c.real();

        if(i < real_n){
            ans.push_back(t);
        }
        else{
            ans[i % real_n] += (long double)t;
        }
    }

    return ans;
}

vector<long double> ans;

void fast_pow(long long exp){
    if(exp == 0){
        ans.clear();
        ans.push_back((long double)1.0);

        return;
    }

    if(exp & 1){
        fast_pow(exp - 1);

        ans = multiply(ans, p);

        return;
    }

    fast_pow(exp >> 1);

    ans = multiply(ans, ans);
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    /*while(true){
        int x, y;
        vector<long double> a, b;

        cin >> x;

        for(int i = 0; i < x; i++){
            long double t;

            cin >> t;

            a.push_back(t);
        }

        cin >> y;

        for(int i = 0; i < y; i++){
            long double t;

            cin >> t;

            b.push_back(t);
        }

        vector<long double> ans = multiply(a, b);

        for(long double t: ans){
            cout << t << " ";
        }

        cout << endl;
    }*/

    int k;

    cin >> real_n >> k;

    for(int i = 0; i < real_n; i++){
        long double x;
        cin >> x;

        p.push_back(x);
    }

    fast_pow(k);


    for(int i = 0; i < real_n; i++){
        cout << fixed << setprecision(8) << ans[i] << " ";
    }
    cout << "\n";

    return 0;
}
