#include <bits/stdc++.h>

using namespace std;

struct edge{
    long long to, len;

    edge(){}
    edge(long long to, long long len){
        this->to = to;
        this->len = len;
    }
};

struct cmp{
    bool operator()(pair<int, long long> lvalue, pair<int, long long> rvalue){
        return lvalue.second > rvalue.second;
    }
};

const long long N = 5e4 + 7;
const long long inf = 1e18;

vector<edge> adjx[N], adjy[N];
bool usedx[N], usedy[N];
long long distx[N], disty[N];
long long nx, ny, mx, my;

long long dijkstrax(int from, int to){
    priority_queue<pair<int, long long>, vector<pair<int, long long> >, cmp> pq;

    for(int i = 1; i <= nx; i++){
        distx[i] = inf;
    }

    pq.push({from, 0});
    distx[from] = 0;

    while(!pq.empty()){
        pair<int, long long> p = pq.top();
        pq.pop();

        int u = p.first;
        long long d = p.second;

        if(usedx[u]){
            continue;
        }
        usedx[u] = true;

        if(u == to){
            return d;
        }

        for(edge e: adjx[u]){
            if(e.len + d < distx[e.to]){
                distx[e.to] = e.len + d;
                pq.push({e.to, distx[e.to]});
            }
        }
    }

    return -1;
}

long long dijkstray(int from, int to){
    priority_queue<pair<int, long long>, vector<pair<int, long long> >, cmp> pq;

     for(int i = 1; i <= ny; i++){
        disty[i] = inf;
    }

    pq.push({from, 0});
    disty[from] = 0;

    while(!pq.empty()){
        pair<int, long long> p = pq.top();
        pq.pop();

        int u = p.first;
        long long d = p.second;

        if(usedy[u]){
            continue;
        }
        usedy[u] = true;

        if(u == to){
            return d;
        }

        for(edge e: adjy[u]){
            if(e.len + d < disty[e.to]){
                disty[e.to] = e.len + d;
                pq.push({e.to, disty[e.to]});
            }
        }
    }

    return -1;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    long long task;

    cin >> task;

    cin >> nx >> mx;

    for(long long i = 0; i < mx; i++){
        long long from, to, len;

        cin >> from >> to >> len;

        adjx[from].push_back(edge(to, len));
        adjx[to].push_back(edge(from, len));
    }
    cin >> ny >> my;

    for(long long i = 0; i < my; i++){
        long long from, to, len;

        cin >> from >> to >> len;

        adjy[from].push_back(edge(to, len));
        adjy[to].push_back(edge(from, len));
    }

    if(task == 1){
        cout << dijkstrax(1, nx) + dijkstray(1, ny) << endl;

        return 0;
    }
}
/*
1
3 2
2 1 15
3 1 14
3 2
2 1 15
3 2 15
*/
