#include<iostream>
#include<vector>
#include<queue>
using namespace std;
const long long maxn = 50000;

long long nx, ny;
long long mx, my;
long long subtask;
vector<pair<long long,long long> > ex[maxn], ey[maxn];

vector<pair<pair<int, int> , int> > edx, edy;

bool visx[maxn], visy[maxn];

void solve1()
{
    priority_queue<pair<long long,long long> > q;
    /// X
    q.push({0,0});
    long long ans = 0;
    while(!q.empty())
    {
        pair<long long,long long> t;
        t = q.top();
        q.pop();
        if(visx[t.second])  continue;
        visx[t.second] = true;
        if(t.second == nx - 1)
        {
            ans += -t.first;
            break;
        }
        for(long long j = 0; j < ex[t.second].size(); j ++)
        {
            pair<long long,long long> i = ex[t.second][j];
            if(!visx[i.first])
            {
                q.push({t.first - i.second, i.first});
            }
        }
    }

    /// Y
    while(!q.empty())   q.pop();
    q.push({0,0});
    while(!q.empty())
    {
        pair<long long,long long> t;
        t = q.top();
        q.pop();
        if(visy[t.second])  continue;
        visy[t.second] = true;
        if(t.second == ny - 1)
        {
            ans += -t.first;
            break;
        }
        for(long long j = 0; j < ey[t.second].size(); j ++)
        {
            pair<long long,long long> i = ey[t.second][j];
            if(!visy[i.first])
            {
                q.push({t.first - i.second, i.first});
            }
        }
    }
    cout << ans;

}

int parx[maxn];
int pary[maxn];

int wx[maxn];
int wy[maxn];


int fnd(int par[], int a)
{
    if(par[par[a]] == a)    return par[a];
    par[a] = fnd(par, par[a]);
    return par[a];
}

bool uni(int par[], int w[], int a, int b)
{
    a = fnd(par, a);
    b = fnd(par, b);
    if(a == b)  return false;
    if(w[a] < w[b]) swap(a, b);

    par[b] = a;
    w[a] += w[b];
    return true;
}


void solve2()
{
    priority_queue<pair<pair<int,int>, pair<int,int> > > q;

    for(int i = 0; i < nx; i ++)
    {
        parx[i] = i;
        wx[i] = 1;
    }
    for(int i = 0; i < ny; i ++)
    {
        pary[i] = i;
        wy[i] = 1;
    }

    for(int i = 0; i < edx.size(); i ++)
    {
        q.push({{-edx[i].second, 1},edx[i].first});
    }
    for(int i = 0; i < edy.size(); i ++)
    {
        q.push({{-edy[i].second, 2},edy[i].first});
    }

    int compx = nx;
    int compy = ny;
    int ans = 0;


    while(compx > 1 || compy > 1)
    {
        pair<pair<int,int>, pair<int,int> > t = q.top();
        q.pop();
        if(t.first.second == 1) /// X
        {
            if(uni(parx, wx, t.second.first, t.second.second))
            {
                compx --;
                ans += -t.first.first * compy;
            }
        } else {
            if(uni(pary, wy, t.second.first, t.second.second))
            {
                compy --;
                ans += -t.first.first * compx;
            }
        }
    }
    cout << ans;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> subtask;
    cin >> nx >> mx;
    for(long long i = 0; i < mx; i ++)
    {
        long long a, b, d;
        cin >> a >> b >> d;
        a --; b --;
        ex[a].push_back({b, d});
        ex[b].push_back({a, d});
        edx.push_back({{a, b}, d});
    }
    cin >> ny >> my;
    for(long long i = 0; i < my; i ++)
    {
        long long a, b, d;
        cin >> a >> b >> d;
        a --; b --;
        ey[a].push_back({b, d});
        ey[b].push_back({a, d});
        edy.push_back({{a, b}, d});
    }
    if(subtask == 1)    solve1();
    else    solve2();
}
/**
1
3 2
2 1 15
3 1 14
3 2
2 1 15
3 2 15
*/

/**
2
3 2
2 1 15
3 1 14
3 2
2 1 15
3 2 15
*/
