#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <queue>
#define pb push_back
#define mp make_pair
#define ll long long
#define pil pair <int, long long>
using namespace std;
const int N = 5e4 + 5;
const ll INF = 1e18;

int task_type;
int nx, ny, mx, my;
vector <pil> gx[N], gy[N];

ll dist[N];
bool vis[N];
ll Djikstra(vector <pil> g[N], int n)
{
    for(int i = 0; i < N; i++)
        dist[i] = INF;
    dist[1] = 0;
    memset(vis, false, sizeof(vis));

    priority_queue <pair <ll, int> > pq;
    pq.push({0, 1});
    while(!pq.empty())
    {
        while(!pq.empty())
        {
            int v = pq.top().second;
            if(vis[v])
                pq.pop();
            else
                break;
        }

        int v = pq.top().second;
        ll w = -(pq.top().first);
        vis[v] = true;
        pq.pop();

        for(auto e: g[v])
        {
            int to = e.first;
            ll len = e.second;

            if(w + len < dist[to])
            {
                dist[to] = w + len;
                pq.push({-dist[to], to});
            }
        }
    }

    return dist[n];
}

ll MST(vector <pil> g[N], int n)
{
    for(int i = 0; i < N; i++)
        dist[i] = INF;
    dist[1] = 0;
    memset(vis, false, sizeof(vis));
    ll res = 0;

    priority_queue <pair <ll, int> > pq;
    pq.push({0, 1});
    while(!pq.empty())
    {
        while(!pq.empty())
        {
            int v = pq.top().second;
            if(vis[v])
                pq.pop();
            else
                break;
        }

        int v = pq.top().second;
        ll w = -(pq.top().first);
        res += w;

        vis[v] = true;
        pq.pop();

        for(auto e: g[v])
        {
            int to = e.first;
            ll len = e.second;

            if(len < dist[to])
            {
                dist[to] = len;
                pq.push({-dist[to], to});
            }
        }
    }

    return res;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int u, v;
    ll w;

    cin >> task_type;
    cin >> nx >> mx;
    for(int i = 1; i <= mx; i++)
    {
        cin >> u >> v >> w;
        gx[u].pb({v, w});
        gx[v].pb({u, w});
    }

    cin >> ny >> my;
    for(int i = 1; i <= my; i++)
    {
        cin >> u >> v >> w;
        gy[u].pb({v, w});
        gy[v].pb({u, w});
    }

    if(task_type == 1)
        cout << Djikstra(gx, nx) + Djikstra(gy, ny) << endl;
    else
    {
        ll ans;
        ans = min(MST(gx, nx) * ny + MST(gy, ny), MST(gx, nx) + MST(gy, ny) * nx);
        cout << ans << endl;
    }


    return 0;
}

/*
1
3 2
2 1 15
3 1 14
3 2
2 1 15
3 2 15

*/

/*

2
3 2
2 1 15
3 1 14
3 2
2 1 15
3 2 15

*/
