#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <iomanip>
#include <cassert>
#define pb push_back
#define mp make_pair
#define ll long long
using namespace std;
typedef vector <vector <double> > Matrix;
const int N = 2e3 + 5;

Matrix mul(Matrix &A, Matrix &B)
{
    assert(A[0].size() == B.size());
    int n = (int)A.size(), m = (int)B[0].size();
    Matrix C;
    C.resize(n);
    for(int i = 0; i < n; i++)
        C[i].resize(m);

    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
        {
            C[i][j] = 0;
            for(int k = 0; k < (int)A[0].size(); k++)
                C[i][j] += (A[i][k] * B[k][j]);
        }

    return C;
}

int n, k;
Matrix p;

Matrix base, res;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;
    p.resize(1);
    p[0].resize(n);
    for(int i = 0; i < n; i++)
        cin >> p[0][i];

    base.resize(n);
    for(int i = 0; i < n; i++)
        base[i].resize(n);
    for(int j = 0; j < n; j++)
    {
        for(int i = 0; i < n; i++)
        {
            int start = (j + n - i) % n;
            base[i][j] = p[0][start];
        }
    }

    res.resize(n);
    for(int i = 0; i < n; i++)
    {
        res[i].resize(n);
        res[i][i] = 1;
    }

    while(k)
    {
        if(k & 1)
            res = mul(res, base);

        base = mul(base, base);
        k >>= 1;
    }

    p[0][0] = 1;
    for(int i = 1; i < n; i++)
        p[0][i] = 0;
    p = mul(p, res);

    for(int i = 0; i < n; i++)
        cout << setprecision(6) << p[0][i] << " ";
    cout << endl;


    return 0;
}

/*

3 2
0.1 0.4 0.5

*/
