#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <iomanip>
#include <cassert>
#define pb push_back
#define mp make_pair
#define ll long long
using namespace std;
const int N = 2e3 + 5;

int n;
ll k;

vector <double> base, cur;
vector <double> a_col;
void square_cur()
{
    vector <double> temp(n, 0);
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < n; j++)
        {
            int row_id = (j + n - i) % n;
            temp[i] += cur[j] * cur[a_col[row_id]];
        }
    }

    cur = temp;
}

void mul_by_base()
{
    vector <double> temp(n, 0);
    for(int i = 0; i < n; i++)
        for(int j = 0; j < n; j++)
        {
            int row_id = (i + j) % n;
            temp[i] += base[j] * cur[a_col[row_id]];
        }

    cur = temp;
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;
    base.resize(n);
    for(int i = 0; i < n; i++)
        cin >> base[i];
    a_col.resize(n);
    for(int i = 0; i < n; i++)
        a_col[i] = (n - i) % n;
    cur = base;

    int high_bit;
    for(high_bit = 36; high_bit >= 0; high_bit--)
    {
        if(k & (1LL << high_bit))
            break;
    }

    high_bit--;
    for(; high_bit >= 0; high_bit--)
    {
        square_cur();
        if(k & (1LL << high_bit))
            mul_by_base();
    }

    vector <double> ans(n, 0);
    for(int i = 0; i < n; i++)
        ans[i] = cur[i];

    for(int i = 0; i < n; i++)
        cout << setprecision(4) << ans[i] << " ";
    cout << endl;

    return 0;
}

/*

3 2
0.1 0.4 0.5

*/
