#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <map>
#pragma gcc optimize ("O3")
#pragma gcc target ("sse4")
#define pb push_back
#define mp make_pair
#define ll long long
using namespace std;
const int N = 53;

int n, k;
int p[N];

struct component{

    int sz;
    int in_vertex, out_vertex;

};

component stupid;
bool vis[N];
void DFS(int v)
{
    vis[v] =  true;
    stupid.sz++;
    if(p[v] == 0)
    {
        stupid.out_vertex = v;
        return;
    }
    if(vis[p[v]])
    {
        stupid.sz = -100;
        return;
    }
    DFS(p[v]);
}

vector <int> topsort;
void DFS_topsort(int v)
{
    vis[v] = true;
    if(p[v] != 0 && !vis[p[v]])
        DFS_topsort(p[v]);
    topsort.pb(v);
}

vector <pair <int, int> > ans;
void print_ans()
{
    for(auto x: ans)
        p[x.first] = x.second;
    for(int i = 1; i <= n; i++)
        cout << p[i] << " ";
    cout << endl;
}

map <vector <int>, bool> seen_state;
void bt(vector <component> v)
{
    if(v.empty())
    {
        print_ans();
        exit(0);
    }

    vector <int> state;
    for(int i = 0; i < (int)v.size(); i++)
        state.pb(v[i].sz);
    sort(state.begin(), state.end());
    if(seen_state.find(state) != seen_state.end())
        return;
    seen_state[state] = true;

    vector <component> go;
    for(int i = 0; i < (int)v.size(); i++)
    {
        for(int j = i + 1; j < (int)v.size(); j++)
        {
            int x = (v[i].sz + v[j].sz);
            if(k % x == 0)
            {
                ans.pb({v[i].out_vertex, v[j].in_vertex});
                ans.pb({v[j].out_vertex, v[i].in_vertex});


                go.clear();

                for(int id = 0; id < (int)v.size(); id++)
                {
                    if(id != i && id != j)
                        go.pb(v[id]);
                }

                bt(go);

                ans.pop_back();
                ans.pop_back();
            }
        }
    }

    for(int i = 0; i < (int)v.size(); i++)
    {
        for(int j = i + 1; j < (int)v.size(); j++)
        {
            int x = (v[i].sz + v[j].sz);
            if(k % x > 0)
            {
                component temp = v[i];
                temp.out_vertex = v[j].out_vertex;
                temp.sz += v[j].sz;

                ans.pb({v[i].out_vertex, v[j].in_vertex});

                go.clear();
                go.pb(temp);
                for(int id = 0; id < (int)v.size(); id++)
                {
                    if(id != i && id != j)
                        go.pb(v[id]);
                }

                bt(go);

                ans.pop_back();
            }
        }
    }

    for(int i = 0; i < (int)v.size(); i++)
    {
        if(k % (int)v[i].sz == 0)
        {
            go.clear();
            ans.pb({v[i].out_vertex, v[i].in_vertex});
            for(int id = 0; id < (int)v.size(); id++)
                if(id != i)
                    go.pb(v[id]);

            bt(go);
            ans.pop_back();
        }
    }
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;
    for(int i = 1; i <= n; i++)
        cin >> p[i];

    for(int i = 1; i <= n; i++)
        if(!vis[i])
            DFS_topsort(i);
    reverse(topsort.begin(), topsort.end());

    vector <component> v;
    memset(vis, false, sizeof(vis));
    for(int i = 0; i < n; i++)
    {
        int ver = topsort[i];
        if(!vis[ver])
        {
            stupid.sz = 0;
            stupid.in_vertex = ver;
            DFS(ver);

            if(stupid.sz > 0)
                v.pb(stupid);
        }
    }

    bt(v);


    return 0;
}

/*

11 42
0 0 9 10 6 1 3 0 11 2 0

*/
