#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <iomanip>
#include <cassert>
#include <complex>
#include <cmath>
#define pb push_back
#define mp make_pair
#define ll long long
#define double float
#pragma gcc optimize ("O3")
#pragma gcc target ("sse4")
using namespace std;
const int N = 15005;
const double PI = acos(-1);
const int MAXX = 1e5 + 5;

int precalc[MAXX];
int rev(int x, int log_n)
{
    if(precalc[x] != -1)
        return precalc[x];
    int res = 0;
    for(int i = 0; i < log_n; i++)
    {
        if(x & (1 << i))
            res |= (1 << (log_n - i - 1));
    }
    return precalc[x] = res;
}

typedef complex <double> cd;
bool solved_len[MAXX][2];
cd have_ang[MAXX][2];


void FFT(vector <cd> &a, bool invert)
{
    int n = (int)a.size();
    int log_n = 0;
    while((1 << log_n) < n)
        log_n++;

    for(int i = 0; i < n; i++)
        if(i < rev(i, log_n))
            swap(a[i], a[rev(i, log_n)]);

    for(int len = 2; len <= n; len *= 2)
    {
        double ang = (2.0 * PI / len);
        if(invert)
            ang *= -1;

        if(!solved_len[len][invert])
        {
            solved_len[len][invert] = true;
            have_ang[len][invert] = cd(cos(ang), sin(ang));
        }
        cd wlen = have_ang[len][invert];

        for(int i = 0; i < n; i += len)
        {
            cd w(1, 0);
            for(int j = 0; j < len / 2; j++)
            {
                cd u = a[i + j], v = a[i + j + len / 2] * w;
                a[i + j] = u + v;
                a[i + j + len / 2] = u - v;

                w *= wlen;
            }
        }
    }

    if(invert)
        for(int i = 0; i < n; i++)
            a[i] /= n;
}

vector <double> mult(vector <double> &a, vector <double> &b)
{
    vector <cd> fa(a.begin(), a.end()), fb(b.begin(), b.end());
    int n = 1;
    while(n < max((int)a.size(), (int)b.size()))
        n *= 2;
    n *= 2;

    fa.resize(n);
    fb.resize(n);

    FFT(fa, false);
    FFT(fb, false);

    vector <cd> c(n);
    for(int i = 0; i < n; i++)
        fa[i] *= fb[i];
    FFT(fa, true);

    vector <double> res(n);
    for(int i = 0; i < n; i++)
        res[i] = fa[i].real();
    return res;
}


int n;
ll k;

vector <double> base, cur;
vector <double> a_col;
void square_cur()
{
    vector <double> a(2 * n), b(n);
    for(int i = 0; i < n; i++)
        a[i] = cur[a_col[i]];
    for(int i = n; i < 2 * n; i++)
        a[i] = a[i - n];
    for(int i = 0; i < n; i++)
        b[i] = cur[i];
    reverse(b.begin(), b.end());

    vector <double> c = mult(a, b);
    for(int i = 0; i < n; i++)
        cur[i] = c[n + i - 1];
    //cur[0] = c[2 * n - 1];


//    vector <double> temp(n, 0);
//    for(int i = 0; i < n; i++)
//    {
//        for(int j = 0; j < n; j++)
//        {
//            int row_id = (j + n - i) % n;
//            temp[i] += cur[j] * cur[a_col[row_id]];
//        }
//    }
//
//    cur = temp;
}

void mul_by_base()
{

    vector <double> a(2 * n), b(n);
    for(int i = 0; i < n; i++)
        a[i] = cur[a_col[i]];
    for(int i = n; i < 2 * n; i++)
        a[i] = a[i - n];
    for(int i = 0; i < n; i++)
        b[i] = base[i];
    reverse(b.begin(), b.end());

    vector <double> c = mult(a, b);
    for(int i = 0; i < n; i++)
        cur[i] = c[n + i - 1];

//    vector <double> temp(n, 0);
//    for(int i = 0; i < n; i++)
//        for(int j = 0; j < n; j++)
//        {
//            int row_id = (j + n - i) % n;
//            temp[i] += base[j] * cur[a_col[row_id]];
//        }
//
//    cur = temp;
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;
    base.resize(n);
    for(int i = 0; i < n; i++)
        cin >> base[i];
    a_col.resize(n);
    for(int i = 0; i < n; i++)
        a_col[i] = (n - i) % n;
    cur = base;

    memset(precalc, -1, sizeof(precalc));


    int high_bit;
    for(high_bit = 36; high_bit >= 0; high_bit--)
    {
        if(k & (1LL << high_bit))
            break;
    }

    high_bit--;
    for(; high_bit >= 0; high_bit--)
    {
        square_cur();
        reverse(cur.begin() + 1, cur.end());
        if(k & (1LL << high_bit))
        {
            mul_by_base();
            reverse(cur.begin() + 1, cur.end());
        }
    }


    vector <double> ans(n, 0);
    for(int i = 0; i < n; i++)
        ans[i] = cur[i];

    for(int i = 0; i < n; i++)
        cout << setprecision(8) << ans[i] << " ";
    cout << endl;

    return 0;
}

/*

3 2
0.1 0.4 0.5

*/
