#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 15005;

int n, k;
long double a[MAXN], b[MAXN], c[MAXN], d[MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;
    for (int i = n - 1; i >= 0; -- i)
    {
        cin >> a[i];
        b[i] = a[i];
    }
}

long double p1[MAXN], p2[MAXN];

vector<long double> Karatsuba(int l, int r)
{
    vector<long double> v;
    v.resize((r - l + 1) * 2 - 1);

    if (r - l < 3)
    {
        for (int i = l; i <= r; ++ i)
        {
            for (int j = l; j <= r; ++ j)
            {
                v[i + j - 2 * l] += p1[i] * p2[j];
            }
        }
        return v;
    }

    int mid = (l + r) / 2;
    vector<long double> lp = Karatsuba(l, mid - 1);
    vector<long double> rp = Karatsuba(mid + 0, r);

   /* cout << "lp: " ;
    for (int i = 0; i < lp.size(); ++ i)
    {
        cout << lp[i] << ' ';
    }
    cout << endl;
    cout << "rp: " ;
    for (int i = 0; i < rp.size(); ++ i)
    {
        cout << rp[i] << ' ';
    }
    cout << endl;*/

    for (int i = r; i >= mid; -- i)
    {
        if (mid - r + i - 1 < 0) break;
        p1[i] += p1[mid - r + i - 1];
        p2[i] += p2[mid - r + i - 1];
    }

    vector<long double> tp = Karatsuba(mid + 0, r);

    for (int i = r; i >= mid; -- i)
    {
        if (mid - r + i - 1 < 0) break;
        p1[i] -= p1[mid - r + i - 1];
        p2[i] -= p2[mid - r + i - 1];
    }

    for (int i = tp.size() - 1; i >= 0; -- i)
    {
        if ((int)(lp.size() + i - tp.size()) >= 0)
        {
            // cout << (int)lp.size() + i - tp.size() << ' ' ;
            tp[i] -= lp[lp.size() + i - tp.size()];
        }
        if ((int)(rp.size() + i - tp.size()) >= 0)
        {
            // cout << (int)rp.size() + i - tp.size() << endl;
            tp[i] -= rp[rp.size() + i - tp.size()];
        }
    }

   /* cout << "tp: " ;
    for (int i = 0; i < tp.size(); ++ i)
    {
        cout << tp[i] << ' ';
    }
    cout << endl;*/

    for (int i = v.size() - 1; i >= 0; -- i)
    {
        if ((int)(rp.size() + i - v.size()) < 0) break;
        v[i] += rp[rp.size() + i - v.size()];
    }

   // cout << "!!! " << v.size() << endl;

    int pos = v.size() + mid - r - 1;
    for (int i = pos - 1; i >= 0; -- i)
    {
        // cout << i << ' ' << tp.size() + i - pos << endl;
        if ((int)(tp.size() + i - pos) < 0) break;
        v[i] += tp[tp.size() + i - pos];
    }

    for (int i = 0; i < lp.size(); ++ i)
    {
        v[i] += lp[i];
    }

    return v;
}

int main()
{
    /*int n;
    cin >> n;
    for (int i = 0; i < n; ++ i)
    {
        cin >> p1[i];
    }
    for (int i = 0; i < n; ++ i)
    {
        cin >> p2[i];
    }

    auto v = Karatsuba(0, n - 1);


    for (int e : v)
        cout << e << ' ';
    cout << endl;

    return 0;
    */

    Init();

    d[0] = 1;
    int mask = 1;
    while (mask <= k)
    {
        if (mask & k)
        {
            for (int i = 0; i < n; ++ i)
            {
                p1[i] = d[i];
                p2[i] = b[i];
                d[i] = 0;
            }

            auto res = Karatsuba(0, n - 1);

            int idx = n - 1;
            for (int j = res.size() - 1; j >= 0; -- j)
            {
                if (idx == -1) idx = n - 1;
                d[idx] += res[j];
                idx--;
            }
        }

        for (int i = 0; i < n; ++ i)
        {
            p1[i] = b[i];
            p2[i] = b[i];
            b[i] = 0;
        }

        auto res = Karatsuba(0, n - 1);

        int idx = n - 1;
        for (int j = res.size() - 1; j >= 0; -- j)
        {
            if (idx == -1) idx = n - 1;
            b[idx] += res[j];
            idx--;
        }

        mask <<= 1;
    }

    for (int i = 0; i < n; ++ i)
    {
        cout << d[i] << ' ';
    }

    cout << endl;
    return 0;
}

/*
3 2
0.1 0.4 0.5


5
1 2 3 4 5
1 2 3 4 5
*/

