#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 15003
using namespace std;
typedef long long ll;
typedef long double ld;
using cd = complex <ld>;
const ld PI = acos(-1);
int n, k;
ld p[MAXN];
void read()
{
    cin >> n >> k;
    for (int i = 0; i < n; i++)
        cin >> p[i];
}
void fft(vector <cd> &a, bool invert)
{
    int n = a.size();
    if (n == 1)
        return;
    vector <cd> a1(n / 2), a2(n / 2);
    for (int i = 0; i * 2 < n; i++)
    {
        a1[i] = a[2 * i];
        a2[i] = a[2 * i + 1];
    }
    fft(a1, invert);
    fft(a2, invert);
    ld angle = 2 * PI / n * (invert ? -1 : 1);
    cd w(1), wn(cos(angle), sin(angle));
    for (int i = 0; i * 2 < n; i++)
    {
        a[i] = a1[i] + w * a2[i];
        a[i + n / 2] = a1[i] - w * a2[i];
        if (invert)
        {
            a[i] /= 2;
            a[i + n / 2] /= 2;
        }
        w *= wn;
    }
}
vector <ld> multiply(vector <ld> &a, vector <ld> &b)
{
    vector <cd> fa(a.begin(), a.end()), fb(b.begin(), b.end());
    int n = 1;
    while (n < fa.size() + fb.size())
        n *= 2;
    fa.resize(n);
    fb.resize(n);
    fft(fa, false);
    fft(fb, false);
    for (int i = 0; i < n; i++)
        fa[i] *= fb[i];
    fft(fa, true);
    vector <ld> ans;
    ans.resize(n);
    for (int i = 0; i < n; i++)
        ans[i] = fa[i].real();
    return ans;
}
vector <ld> mult(vector <ld> &a, vector <ld> &b)
{
    vector <ld> ans;
    ans.resize(n);
    vector <ld> temp = multiply(a, b);
    int sz = temp.size();
    for (int i = 0; i < sz; i++)
        ans[i % n] += temp[i];
    return ans;
}
vector <ld> fast_pow(vector <ld> &a, int deg)
{
    vector <ld> ans = a;
    deg--;
    vector <ld> c = a;
    while (deg)
    {
        if (deg & 1)
            ans = mult(ans, c);
        deg >>= 1;
        c = mult(c, c);
    }
    return ans;
}
void solve()
{
    vector <ld> v;
    v.resize(n);
    for (int i = 0; i < n; i++)
        v[i] = p[i];
    auto ans = fast_pow(v, k);
    cout << fixed;
    for (int i = 0; i < n; i++)
        cout << setprecision(9) << ans[i] << " ";
    cout << endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
}
