#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 50003
#define INF 1000000000000000
using namespace std;
typedef long long ll;
typedef long double ld;
int task;
int nx, mx, ny, my;
vector <pair <int, ll> > adjx[MAXN], adjy[MAXN];
void read()
{
    cin >> task;
    cin >> nx >> mx;
    for (int i = 1; i <= mx; i++)
    {
        int a, b;
        ll c;
        cin >> a >> b >> c;
        adjx[a].push_back({b, c});
        adjx[b].push_back({a, c});
    }
    cin >> ny >> my;
    for (int i = 1; i <= my; i++)
    {
        int a, b;
        ll c;
        cin >> a >> b >> c;
        adjy[a].push_back({b, c});
        adjy[b].push_back({a, c});
    }
}
ll dist[MAXN];
ll dejkstrax()
{
    for (int i = 1; i <= nx; i++)
        dist[i] = INF;
        dist[1] = 0;
        set <pair <ll, int> > s;
        s.insert({0, 1});
        while (!s.empty())
        {
            auto curr = *s.begin();
            s.erase(s.begin());
            for (auto i: adjx[curr.second])
                if (i.second + curr.first < dist[i.first])
            {
                if (dist[i.first] != INF)
                s.erase({dist[i.first], i.first});
                dist[i.first] = i.second + curr.first;
                s.insert({dist[i.first], i.first});
            }
        }
    return dist[nx];
}
ll dejkstray()
{
    for (int i = 1; i <= ny; i++)
        dist[i] = INF;
        dist[1] = 0;
        set <pair <ll, int> > s;
        s.insert({0, 1});
        while (!s.empty())
        {
            auto curr = *s.begin();
            s.erase(s.begin());
            for (auto i: adjy[curr.second])
                if (i.second + curr.first < dist[i.first])
            {
                if (dist[i.first] != INF)
                s.erase({dist[i.first], i.first});
                dist[i.first] = i.second + curr.first;
                s.insert({dist[i.first], i.first});
            }
        }
    return dist[ny];
}
struct edge
{
    pair <int, int> a, b;
    ll c;
    edge() {}
    edge(pair <int, int> _a, pair <int, int> _b, ll _c)
    {
        a = _a;
        b = _b;
        c = _c;
    }
};
bool cmp(edge a, edge b)
{
    return a.c < b.c;
}
vector <edge> edges;
pair <int, int> par[203][203];
pair <int, int> find(pair <int, int> a)
{
    if (par[a.first][a.second] == a)
        return a;
    return par[a.first][a.second] = find(par[a.first][a.second]);
}

void merge(pair <int, int> a, pair <int, int> b)
{
    pair <int, int> a_root = find(a), b_root = find(b);
    par[b_root.first][b_root.second] = a_root;
}
void solve()
{
    if (task == 1)
        cout << dejkstrax() + dejkstray() << endl;
    else
    {
        for (int i = 1; i <= nx; i++)
            for (int j = 1; j <= ny; j++)
                for (auto k: adjy[j])
            edges.push_back(edge({i, j}, {i, k.first}, k.second));
        for (int i = 1; i <= ny; i++)
            for (int j = 1; j <= nx; j++)
            for (auto k: adjx[j])
        edges.push_back(edge({j, i}, {k.first, i}, k.second));
        sort (edges.begin(), edges.end(), cmp);
        ll ans = 0;
        for (int i = 1; i <= nx; i++)
            for (int j = 1; j <= ny; j++)
        par[i][j] = {i, j};
        for (auto i: edges)
            if (find(i.a) != find(i.b))
        {
            merge(i.a, i.b);
            ans += i.c;
        }
        cout << ans << endl;
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
}
