#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 15003
using namespace std;
typedef long long ll;
typedef long double ld;
using cd = complex <double>;
const ld PI = acos(-1);
int n, k;
ld p[MAXN];
void read()
{
    cin >> n >> k;
    for (int i = 0; i < n; i++)
        cin >> p[i];
}
void fft(vector <cd> &a, bool invert)
{
    int n = a.size();
    for (int i = 1, j = 0; i < n; i++)
    {
        int bit = n >> 1;
        for (; j & bit; bit >>= 1)
            j ^= bit;
        j ^= bit;
        if (i < j)
            swap(a[i], a[j]);
    }
    for (int len = 2; len <= n; len <<= 1)
    {
        ld angle = 2 * PI / len * (invert ? -1 : 1);
        cd wn(cos(angle), sin(angle)), w(1);
        for (int i = 0; i < n; i += len)
        {
            cd w(1);
            for (int j = 0; j < (len >> 1); j++)
            {
                cd u = a[i + j], v = a[i + j + (len >> 1)] * w;
                a[i + j] = u + v;
                a[i + j + (len >> 1)] = u - v;
                w *= wn;
            }
        }
    }
    if (invert)
        for (auto &i: a)
        i /= n;
}
vector <ld> multiply(vector <ld> &a, vector <ld> &b)
{
    vector <cd> fa(a.begin(), a.end()), fb(b.begin(), b.end());
    int n = 1;
    while (n < fa.size() + fb.size())
        n <<= 1;
    fa.resize(n);
    fb.resize(n);
    fft(fa, false);
    fft(fb, false);
    for (int i = 0; i < n; i++)
        fa[i] *= fb[i];
    fft(fa, true);
    vector <ld> ans;
    ans.resize(n);
    for (int i = 0; i < n; i++)
        ans[i] = fa[i].real();
    return ans;
}
vector <ld> mult(vector <ld> &a, vector <ld> &b)
{
    vector <ld> ans;
    ans.resize(n);
    vector <ld> temp = multiply(a, b);
    int sz = temp.size();
    for (int i = 0; i < sz; i++)
        ans[i % n] += temp[i];
    return ans;
}
vector <ld> fast_pow(vector <ld> &a, int deg)
{
    vector <ld> ans = a;
    deg--;
    vector <ld> c = a;
    while (deg)
    {
        if (deg & 1)
            ans = mult(ans, c);
        deg >>= 1;
        c = mult(c, c);
    }
    return ans;
}
void solve()
{
    vector <ld> v;
    v.resize(n);
    for (int i = 0; i < n; i++)
        v[i] = p[i];
    auto ans = fast_pow(v, k);
    cout << fixed;
    for (int i = 0; i < n; i++)
        cout << setprecision(12) << ans[i] << " ";
    cout << endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
}
