#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 50003
#define INF 1000000000000000
using namespace std;
typedef long long ll;
typedef long double ld;
int task;
int nx, mx, ny, my;
vector <pair <int, ll> > adjx[MAXN], adjy[MAXN];
struct edge
{
    int a, b;
    ll c;
    bool is;
    edge() {}
    edge(int _a, int _b, ll _c, bool _is)
    {
        a = _a;
        b = _b;
        c = _c;
        is = _is;
    }
};
vector <edge> edges;
void read()
{
    cin >> task;
    cin >> nx >> mx;
    for (int i = 1; i <= mx; i++)
    {
        int a, b;
        ll c;
        cin >> a >> b >> c;
        adjx[a].push_back({b, c});
        adjx[b].push_back({a, c});
        edges.push_back(edge(a, b, c, true));
    }
    cin >> ny >> my;
    for (int i = 1; i <= my; i++)
    {
        int a, b;
        ll c;
        cin >> a >> b >> c;
        adjy[a].push_back({b, c});
        adjy[b].push_back({a, c});
        edges.push_back(edge(a, b, c, false));
    }
}
ll dist[MAXN];
ll dejkstrax()
{
    for (int i = 1; i <= nx; i++)
        dist[i] = INF;
        dist[1] = 0;
        set <pair <ll, int> > s;
        s.insert({0, 1});
        while (!s.empty())
        {
            auto curr = *s.begin();
            s.erase(s.begin());
            for (auto i: adjx[curr.second])
                if (i.second + curr.first < dist[i.first])
            {
                if (dist[i.first] != INF)
                s.erase({dist[i.first], i.first});
                dist[i.first] = i.second + curr.first;
                s.insert({dist[i.first], i.first});
            }
        }
    return dist[nx];
}
ll dejkstray()
{
    for (int i = 1; i <= ny; i++)
        dist[i] = INF;
        dist[1] = 0;
        set <pair <ll, int> > s;
        s.insert({0, 1});
        while (!s.empty())
        {
            auto curr = *s.begin();
            s.erase(s.begin());
            for (auto i: adjy[curr.second])
                if (i.second + curr.first < dist[i.first])
            {
                if (dist[i.first] != INF)
                s.erase({dist[i.first], i.first});
                dist[i.first] = i.second + curr.first;
                s.insert({dist[i.first], i.first});
            }
        }
    return dist[ny];
}

bool cmp(edge a, edge b)
{
    return a.c < b.c;
}
int cnt_x, cnt_y;
int parx[MAXN], pary[MAXN];
int findx(int ver)
{
    if (parx[ver] == ver)
        return ver;
    return parx[ver] = findx(parx[ver]);
}
int findy(int ver)
{
    if (pary[ver] == ver)
        return ver;
    return pary[ver] = findy(pary[ver]);
}
void mergex(int a, int b)
{
    int root_a = findx(a), root_b = findx(b);
    parx[root_b] = root_a;
}
void mergey(int a, int b)
{
    int root_a = findy(a), root_b = findy(b);
    pary[root_b] = root_a;
}
void solve()
{
    if (task == 1)
        cout << dejkstrax() + dejkstray() << endl;
    else
    {
        cnt_x = nx;
        cnt_y = ny;
        sort (edges.begin(), edges.end(), cmp);
        for (int i = 1; i <= nx; i++)
            parx[i] = i;
        for (int i = 1; i <= ny; i++)
            pary[i] = i;
        ll ans = 0;
        for (auto i: edges)
        {
            if (i.is)
            {
                if (findx(i.a) != findx(i.b))
                {
                    ans += cnt_y * i.c;
                    mergex(i.a, i.b);
                    cnt_x--;
                }
            }
            else
            {
                if (findy(i.a) != findy(i.b))
                {
                    ans += cnt_x * i.c;
                    mergey(i.a, i.b);
                    cnt_y--;
                }
            }
        }
        cout << ans << endl;
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
}
