#include <bits/stdc++.h>

const int32_t MAX_N = 5e4;

struct State {
	int32_t first;
	int64_t second;

	State() {}
	State(int32_t _first, int64_t _second) : first(_first), second(_second) {}

	bool operator< (const State &o) const {
		return second > o.second;
	}
};

bool vis[2][MAX_N + 5];
int64_t dists[2][MAX_N + 5];
std::vector< std::pair< int32_t, int32_t > > g[2][MAX_N + 5];

void dijkstra(int32_t x, int32_t start) {
	std::priority_queue< State > pq;

	dists[x][start] = 0;
	pq.push(State(start, 0));

	while(!pq.empty()) {
		auto curr = pq.top();
		pq.pop();

		int32_t p = curr.first;
		int64_t dist = curr.second;

		if(vis[x][p]) {
			continue;
		}
		vis[x][p] = true;

		for(auto &q : g[x][p]) {
			int32_t nxt = q.first;
			int64_t newD = dist + q.second;

			if(!vis[x][nxt] && (dists[x][nxt] == -1 || dists[x][nxt] > newD)) {
				pq.push(State(nxt, newD));
				dists[x][nxt] = newD;
			}
		}
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int32_t task;
	std::cin >> task;

	int32_t nx, mx;
	std::cin >> nx >> mx;

	for(int32_t i = 0; i < mx; i++) {
		int32_t u, v, w;
		std::cin >> u >> v >> w;

		g[0][u].push_back({ v, w });
		g[0][v].push_back({ u, w });
	}

	int32_t ny, my;
	std::cin >> ny >> my;

	for(int32_t i = 0; i < my; i++) {
		int32_t u, v, w;
		std::cin >> u >> v >> w;

		g[1][u].push_back({ v, w });
		g[1][v].push_back({ u, w });
	}

	if(task == 1) {
		memset(dists, -1, sizeof(dists));

		dijkstra(0, 1);
		dijkstra(1, 1);

		std::cout << dists[0][nx] + dists[1][ny] << '\n';
	}
}
