#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC unloop("sse4, sse3")

const int32_t MAX_N = 15000;
const long double EPS = 1e-9;

bool isZero[MAX_N + 5];
int32_t n;

inline long double get_val(const std::vector< long double > &x, int32_t row, int32_t col) {
	if(col >= row) {
		return x[col - row];
	}
	else {
		return x[n - row + col];
	}
}

inline std::vector< long double > multiply(const std::vector< long double > &x, const std::vector< long double > &y) {
	std::vector< long double > ans(n, 0);
	
	for(int32_t i = 0; i < n; i++) {
		if(isZero[i]) {
			continue;
		}
		for(int32_t p = 0; p < n; p++) {
			ans[i] += get_val(x, 0, p) * get_val(y, p, i);
		}
	}

	return ans;
}

std::vector< long double > fast_pow(const std::vector< long double > &mat, int32_t k) {
	/**
	for(int32_t i = 0; i < n; i++) {
		if(mat[i] < EPS) {
			isZero[i] = true;
		}
	}*/
	
	if(k == 1) {
		return mat;
	}
	else if(k % 2 == 0) {
		auto aux = fast_pow(mat, k / 2);
		return multiply(aux, aux);
	}
	else {
		auto aux = fast_pow(mat, k - 1);
		return multiply(aux, mat);
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int32_t k;
	std::cin >> n >> k;
	
	std::vector< long double > mat(n);
	for(int32_t i = 0; i < n; i++) {
		std::cin >> mat[i];
	}
	mat = fast_pow(mat, k);
		
	for(int32_t i = 0; i < n; i++) {
		std::cout << mat[i] << " ";
	}
	std::cout << '\n';
}
