#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC unloop("sse4, sse3")

const int32_t MAX_N = 15000;
const double EPS = 1e-9;

bool isZero[MAX_N + 5];
int32_t n;

inline double get_val(const std::vector< double > &x, int32_t row, int32_t col) {
	if(col >= row) {
		return x[col - row];
	}
	else {
		return x[n - row + col];
	}
}

inline std::vector< double > multiply(const std::vector< double > &x, const std::vector< double > &y) {
	std::vector< double > ans(n, 0);
	
	for(int32_t i = 0; i < n; i++) {
		for(int32_t p = 0; p < n; p++) {
			ans[i] += get_val(x, 0, p) * get_val(y, p, i);
		}
	}

	return ans;
}

std::vector< double > fast_pow(const std::vector< double > &mat, int32_t k) {
	std::vector< double > res = mat;
	for(int32_t i = 0; (1 << i) <= k; i++) {
		if((k & (1 << i)) != 0) {
			res = multiply(res, res);
		}
		else {
			res = multiply(res, mat);
		}
	}
	return res;
	
	/**if(k == 1) {
		return mat;
	}
	else if(k % 2 == 0) {
		auto aux = fast_pow(mat, k / 2);
		return multiply(aux, aux);
	}
	else {
		auto aux = fast_pow(mat, k - 1);
		return multiply(aux, mat);
	}*/
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int32_t k;
	std::cin >> n >> k;
	
	std::vector< double > mat(n);
	for(int32_t i = 0; i < n; i++) {
		std::cin >> mat[i];
	}
	mat = fast_pow(mat, k - 1);
		
	for(int32_t i = 0; i < n; i++) {
		std::cout << mat[i] << " ";
	}
	std::cout << '\n';
}
