#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC unloop("sse4, sse3")

const int32_t MAX_N = 15000;
const double EPS = 1e-6;

int32_t n;

inline double get_val(const std::array< double, MAX_N > &x, int32_t row, int32_t col) {
	if(col >= row) {
		return x[col - row];
	}
	else {
		return x[n - row + col];
	}
}

std::array< double, MAX_N > multiply(const std::array< double, MAX_N > &x, const std::array< double, MAX_N > &y) {
	std::array< double, MAX_N > ans;
	
	double sum = 0;
	for(int32_t i = 0; i < n; i++) {
		ans[i] = 0;

		for(int32_t p = 0; p < n; p++) {
			ans[i] += get_val(x, 0, p) * get_val(y, p, i);
		}

		sum += ans[i];
		if(sum > 1 - EPS) {
			break;
		}
	}

	return ans;
}

std::array< double, MAX_N > fast_pow(const std::array< double, MAX_N > &mat, int32_t k) {
	if(k == 1) {
		return mat;
	}
	else if(k % 2 == 0) {
		auto aux = fast_pow(mat, k / 2);
		return multiply(aux, aux);
	}
	else {
		auto aux = fast_pow(mat, k - 1);
		return multiply(aux, mat);
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int32_t k;
	std::cin >> n >> k;
	
	std::array< double, MAX_N > mat;
	for(int32_t i = 0; i < n; i++) {
		std::cin >> mat[i];
	}

	if(n <= 2000) {
		mat = fast_pow(mat, k);
	}
	else {
		mat = fast_pow(mat, k);
	}
	for(int32_t i = 0; i < n; i++) {
		std::cout << mat[i] << " ";
	}
	std::cout << '\n';
}
