#include<iostream>
#include<bitset>
#include<vector>
#include<complex>
#include<iomanip>
using namespace std;
vector<double> mat(16384);
vector<double> res(16384);
long long n,k;
double twopi=acos(-1)*2;
complex<double> epow(double alpha)
{
    return {cos(alpha),sin(alpha)};
}
void fft(complex<double> *a,complex<double> *b,int n,int dir,int step)
{
    if(n<1){return;}
    if(n==1)
    {
        b[0]=a[0];
        return;
    }
    fft(a,b,n/2,dir,step*2);
    fft(a+step,b+n/2,n/2,dir,step*2);
    for(int i=0;i<n/2;i++)
    {
        complex<double> even=b[i];
        complex<double> odd=b[i+n/2];
        b[i]=even+epow(dir*twopi*(double)((double)(i)/(double)(n)))*odd;
        b[i+n/2]=even+epow(dir*twopi*(double)((double)(i+n/2)/(double)(n)))*odd;
    }
    return;
}
vector<double> poly_mult(vector<double> &x,vector<double> &y)
{
    int n=1;
    while(x.size()>n or y.size()>n)
    {
        n<<=1;
    }
    n<<=1;
    complex<double> *a= new complex<double>[n];
    complex<double> *b= new complex<double>[n];
    complex<double> *A= new complex<double>[n];
    complex<double> *B= new complex<double>[n];
    for(int i=0;i<x.size();i++)
    {
        a[i]={x[i],0};
    }
    for(int i=0;i<y.size();i++)
    {
        b[i]={y[i],0};
    }
    fft(a,A,n,1,1);
    fft(b,B,n,1,1);
    for(int i=0;i<n;i++)
    {
        A[i]=A[i]*B[i];
    }
    fft(A,a,n,-1,1);
    vector<double> res;
    for(int i=0;i<x.size()+y.size()-1;i++)
    {
        //cout<<a[i].real()<<"AA";
        res.push_back((double)(1/(double)n)*(a[i].real()));
        /*<<(fixed);
        cout<<res[res.size()-1]<<"\n";*/
    }
    return res;
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n>>k;
    for(int i=0;i<n;i++)
    {
        cin>>mat[i];
        res[i]=0;
    }
    res[0]=1;
    while(k!=0)
    {
        if(k%2)
        {
            res=poly_mult(res,mat);
            for(int i=n;i<res.size();i++)
            {
                res[i%n]+=res[i];
            }
            res.erase(res.begin()+n,res.end());
        }
        mat=poly_mult(mat,mat);
        for(int i=n;i<mat.size();i++)
        {
            mat[i%n]+=mat[i];
        }
            mat.erase(mat.begin()+n,mat.end());
        k>>=1;
    }
    cout<<fixed;
    for(int i=0;i<n;i++)
    {
        cout<<res[i]<<" ";
    }
    cout<<endl;
    return 0;
}
