#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdint>

using namespace std;

vector<uint16_t> p;
uint32_t k;

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    uint16_t n;
    cin>>n>>k;
    p.resize(n);
    for(uint16_t i=0; i<n; i++)
        cin>>p[i];
}

vector<bool> depth_used;

uint32_t find_depth (uint32_t cur)
{
    uint32_t res=0;
    while(depth_used[cur]==false)
    {
        res++;
        depth_used[cur]=true;
        cur=p[cur]-1;
    }

    return res;
}

uint64_t nok(const vector<uint32_t> &v)
{
    uint64_t res=1;
    for(uint64_t x:v)
    {
        res=(res*x)/__gcd(res, x);
    }
    return res;
}

void simulate()
{
    /*
    for(auto x:p)
        cout<<x<<' ';
    cout<<endl;
    */

    fill(depth_used.begin(), depth_used.end(), false);

    vector<uint32_t> depth_arr;
    for(uint16_t i=0; i<p.size(); i++)
    {
        if(depth_used[i]==false)
        {
            depth_arr.push_back(find_depth(i));
        }
    }

    /*
    for(auto x:depth_arr)
        cout<<x<<' ';
    cout<<endl;

    cout<<nok(depth_arr)<<endl;
    */

    uint64_t res=nok(depth_arr);

    if((uint64_t)k%res==0)
    {
        for(auto x:p)
            cout<<x<<' ';
        cout<<endl;
        exit(0);
    }
}

void generate_perm()
{
    depth_used.resize(p.size()+1);
    vector<uint16_t> poses;
    vector<bool> used(p.size()+5);
    vector<uint16_t> sub_perm;
    for(uint16_t i=0; i<p.size(); i++)
    {
        if(p[i]==0)
        {   poses.push_back(i);
            //cout<<i<<endl;
        }
        else
            used[p[i]]=true;
    }
    for(uint16_t i=1; i<=p.size(); i++)
    {
        if(used[i]==false)
            sub_perm.push_back(i);
    }

    /*
    for(auto x:sub_perm)
        cout<<x<<' ';
    cout<<endl;
    */

    do
    {
        for(uint32_t i=0; i<sub_perm.size(); i++)
        {
            p[poses[i]]=sub_perm[i];
        }
        simulate();
        //exit(0);
    }while(next_permutation(sub_perm.begin(), sub_perm.end()));

}

int main()
{
    init();
    generate_perm();


}
