#include <bits/stdc++.h>

#define endl '\n'
#define trace(x) cerr << #x << " = " << x <<endl
#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())

using namespace std;
template<class T, class T1> inline bool chkmax(T &x, const T1 &y) { return x < y ? x = y, true : false; }
template<class T, class T1> inline bool chkmin(T &x, const T1 &y) { return x > y ? x = y, true : false; }

const int MAX_ID = 40001;

int nx, mx;
map<pair<int, int>, int> x_edges;
int ny, my;
map<pair<int, int>, int> y_edges;
vector<pair<int, int>> g[MAX_ID];
int used[MAX_ID];
int timestamp = 0;

int dikstra(int from, int to) {
    timestamp++;
    priority_queue<pair<int, int>> q;
    q.emplace(0, from);
    while (!q.empty()) {
        pair<int, int> now = q.top();
        q.pop();
        if (now.second == to) return -now.first;
        if (used[now.second] == timestamp) continue;
        used[now.second] = timestamp;
        now.first *= -1;
        for (pair<int, int> adj : g[now.second]) {
            if (used[adj.first] != timestamp) q.emplace(-now.first - adj.second, adj.first);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int type;
    cin >> type;
    cin >> nx >> mx;
    for (int i = 1; i <= mx; i++) {
        int u, v, l;
        cin >> u >> v >> l;
        if (u > v) swap(u, v);
        x_edges[{u, v}] = l;
    }
    cin >> ny >> my;
    for (int i = 1; i <= my; i++) {
        int u, v, l;
        cin >> u >> v >> l;
        if (u > v) swap(u, v);
        y_edges[{u, v}] = l;
    }

    vector<pair<int, int>> points;
    for (int i = 1; i <= nx; i++) {
        for (int j = 1; j <= ny; j++) points.emplace_back(i, j);
    }
    for (int i = 0; i < sz(points); i++) {
        for (int j = i + 1; j < sz(points); j++) {
            if (points[i].first == points[j].first) {
                int u = points[i].second;
                int v = points[j].second;
                if (u > v) swap(u, v);
                if (y_edges.count({u, v})) {
                    int l = y_edges[{u, v}];
                    g[i + 1].emplace_back(j + 1, l);
                    g[j + 1].emplace_back(i + 1, l);
                }
            } else if (points[i].second == points[j].second) {
                int u = points[i].first;
                int v = points[j].first;
                if (u > v) swap(u, v);
                if (x_edges.count({u, v})) {
                    int l = x_edges[{u, v}];
                    g[i + 1].emplace_back(j + 1, l);
                    g[j + 1].emplace_back(i + 1, l);
                }
            }
        }
    }

    if (type == 1) cout << dikstra(1, nx * ny) << endl;
    else {
        ///.....
    }

    return EXIT_SUCCESS;
}
