#include <bits/stdc++.h>

#define endl '\n'
#define trace(x) cerr << #x << " = " << x <<endl
#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())

using namespace std;
template<class T, class T1> inline bool chkmax(T &x, const T1 &y) { return x < y ? x = y, true : false; }
template<class T, class T1> inline bool chkmin(T &x, const T1 &y) { return x > y ? x = y, true : false; }

const int MAX_ID = 300001;
const int MAXM = (int)5e4 + 1;

struct edge {
    int u;
    int v;
    int length;
};

int type;
int nx, mx;
edge x[MAXM];
int ny, my;
edge y[MAXM];

map<pair<int, int>, int> ids;

inline int get_id(int x, int y) {
    pair<int, int> p = {x, y};
    int id = sz(ids);
    if (ids.find(p) == ids.end()) ids[p] = id;
    return ids[p];
}

vector<pair<int, int>> g[MAX_ID];
int used[MAX_ID];
int timestamp = 0;

int dikstra(int from, int to) {
    timestamp++;
    priority_queue<pair<int, int>> q;
    q.emplace(0, from);
    while (!q.empty()) {
        pair<int, int> now = q.top();
        q.pop();
        if (now.second == to) return -now.first;
        if (used[now.second] == timestamp) continue;
        used[now.second] = timestamp;
        now.first *= -1;
        for (pair<int, int> adj : g[now.second]) {
            if (used[adj.first] != timestamp) q.emplace(-now.first - adj.second, adj.first);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> type;
    cin >> nx >> mx;
    for (int i = 1; i <= mx; i++) cin >> x[i].u >> x[i].v >> x[i].length;
    cin >> ny >> my;
    for (int i = 1; i <= my; i++) cin >> y[i].u >> y[i].v >> y[i].length;

    for (int i = 0; i < nx; i++) {
        for (int y = 1; y <= ny; y++) {
            int id1 = get_id(x[i].u, y);
            int id2 = get_id(x[i].v, y);
            g[id1].emplace_back(id2, x[i].length);
            g[id2].emplace_back(id1, x[i].length);
        }
    }

    for (int i = 0; i < ny; i++) {
        for (int x = 1; x <= nx; x++) {
            int id1 = get_id(x, y[i].u);
            int id2 = get_id(x, y[i].v);
            g[id1].emplace_back(id2, y[i].length);
            g[id2].emplace_back(id1, y[i].length);
        }
    }

    if (type == 1) {
        memset(used, 0, sizeof(used));
        cout << dikstra(get_id(1, 1), get_id(nx, ny)) << endl;
    }

    return EXIT_SUCCESS;
}
