#include <bits/stdc++.h>

#define endl '\n'
#define trace(x) cerr << #x << " = " << x <<endl
#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())

using namespace std;
template<class T, class T1> inline bool chkmax(T &x, const T1 &y) { return x < y ? x = y, true : false; }
template<class T, class T1> inline bool chkmin(T &x, const T1 &y) { return x > y ? x = y, true : false; }

const int MAX_ID = 300001;
const int MAXM = (int)5e4 + 1;

struct edge {
    int u;
    int v;
    int length;

    bool operator <(const edge &other) const {
        return this->length < other.length;
    }
};

struct dsu {
    vector<int> parent;
    vector<int> rank;

    void init(int sz) {
        this->parent.resize(sz + 1, -1);
        this->rank.resize(sz + 1, 0);
    }

    int root(int node) {
        if (this->parent[node] == -1) return node;
        return this->parent[node] = this->root(this->parent[node]);
    }

    void unite(int u, int v) {
        u = this->root(u);
        v = this->root(v);
        if (u != v) {
            if (this->rank[u] < this->rank[v]) swap(u, v);
            this->parent[v] = u;
            if (this->rank[u] == this->rank[v]) this->rank[u]++;
        }
    }
};

int type;
int nx, mx;
edge x[MAXM];
int ny, my;
edge y[MAXM];

map<pair<int, int>, int> ids;

inline int get_id(int x, int y) {
    pair<int, int> p = {x, y};
    int id = sz(ids);
    if (ids.find(p) == ids.end()) ids[p] = id;
    return ids[p];
}

vector<pair<int, int>> g[MAX_ID];
int used[MAX_ID];
int timestamp = 0;

int dikstra(int from, int to) {
    timestamp++;
    priority_queue<pair<int, int>> q;
    q.emplace(0, from);
    while (!q.empty()) {
        pair<int, int> now = q.top();
        q.pop();
        if (now.second == to) return -now.first;
        if (used[now.second] == timestamp) continue;
        used[now.second] = timestamp;
        now.first *= -1;
        for (pair<int, int> adj : g[now.second]) {
            if (used[adj.first] != timestamp) q.emplace(-now.first - adj.second, adj.first);
        }
    }
}

vector<edge> g2;

int mst() {
    sort(all(g2));
    int ans = 0;
    dsu sets;
    sets.init(sz(ids) + 1);
    for (edge &now : g2) {
        if (sets.root(now.u) == sets.root(now.v)) continue;
        ans += now.length;
        sets.unite(now.u, now.v);
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> type;
    cin >> nx >> mx;
    for (int i = 1; i <= mx; i++) cin >> x[i].u >> x[i].v >> x[i].length;
    cin >> ny >> my;
    for (int i = 1; i <= my; i++) cin >> y[i].u >> y[i].v >> y[i].length;

    if (type == 1) {
        for (int i = 0; i < nx; i++) {
            for (int y = 1; y <= ny; y++) {
                int id1 = get_id(x[i].u, y);
                int id2 = get_id(x[i].v, y);
                g[id1].emplace_back(id2, x[i].length);
                g[id2].emplace_back(id1, x[i].length);
            }
        }

        for (int i = 0; i < ny; i++) {
            for (int x = 1; x <= nx; x++) {
                int id1 = get_id(x, y[i].u);
                int id2 = get_id(x, y[i].v);
                g[id1].emplace_back(id2, y[i].length);
                g[id2].emplace_back(id1, y[i].length);
            }
        }

        memset(used, 0, sizeof(used));
        cout << dikstra(get_id(1, 1), get_id(nx, ny)) << endl;
    } else {
        edge help;
        for (int i = 0; i < nx; i++) {
            for (int y = 1; y <= ny; y++) {
                int id1 = get_id(x[i].u, y);
                int id2 = get_id(x[i].v, y);
                help.u = id1;
                help.v = id2;
                help.length = x[i].length;
                g2.emplace_back(help);
            }
        }

        for (int i = 0; i < ny; i++) {
            for (int x = 1; x <= nx; x++) {
                int id1 = get_id(x, y[i].u);
                int id2 = get_id(x, y[i].v);
                help.u = id1;
                help.v = id2;
                help.length = y[i].length;
                g2.emplace_back(help);
            }
        }

        cout << mst() << endl;
    }

    return EXIT_SUCCESS;
}
