#include <iostream>
#include <vector>
#include <queue>
using namespace std;

typedef long long Int;

const Int INF=(1e18)+5;
const int N=(1e5)+5;

Int dist1[N],dist2[N];
vector < pair <int,int> > g1[N],g2[N];
priority_queue < pair <Int,int> > pq;
bool used1[N],used2[N];

int main()
{

ios::sync_with_stdio(false);
cin.tie(nullptr);

int task,nx,mx,ny,my,i,u,v,w,from,to;
Int cost;

cin>>task;

cin>>nx>>mx;

 for(i=1;i<=mx;i++)
 {
  cin>>u>>v>>w;
  g1[u].push_back(make_pair(v,w));
  g1[v].push_back(make_pair(u,w));
 }

cin>>ny>>my;

 for(i=1;i<=my;i++)
 {
  cin>>u>>v>>w;
  g2[u].push_back(make_pair(v,w));
  g2[v].push_back(make_pair(u,w));
 }

 for(i=1;i<=ny;i++)
  dist2[i]=INF;

pq.push(make_pair(0,1));
dist2[1]=0;
 while(!pq.empty())
 {
  from=pq.top().second;

   if(used2[from])
    continue;

  used2[from]=true;
  pq.pop();

   for(i=0;i<g2[from].size();i++)
   {
    to=g2[from][i].first;
    cost=g2[from][i].second;

     if(dist2[from]+cost<dist2[to])
     {
      dist2[to]=dist2[from]+cost;
      pq.push(make_pair(-dist2[to],to));
     }
   }
 }

 for(i=1;i<=nx;i++)
  dist1[i]=INF;

pq.push(make_pair(0,1));
dist1[1]=0;
 while(!pq.empty())
 {
  from=pq.top().second;

   if(used1[from])
    continue;

  used1[from]=true;
  pq.pop();

   for(i=0;i<g1[from].size();i++)
   {
    to=g1[from][i].first;
    cost=g1[from][i].second;

     if(dist1[from]+cost<dist1[to])
     {
      dist1[to]=dist1[from]+cost;
      pq.push(make_pair(-dist1[to],to));
     }
   }
 }

cout<<dist1[nx]+dist2[ny]<<"\n";

return 0;
}
